

import android.content.res.Resources
import android.graphics.Bitmap
import android.graphics.Canvas
import android.graphics.drawable.BitmapDrawable
import android.graphics.drawable.Drawable
import android.text.Html
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.RoomParkApplication
import com.google.android.material.textview.MaterialTextView
import com.squareup.picasso.Picasso
import com.squareup.picasso.Target
import kotlin.math.min


class PicassoImageGetter(private val target: MaterialTextView) : Html.ImageGetter {

    override fun getDrawable(source: String): Drawable {
        val drawable = BitmapDrawablePlaceHolder()
        Picasso.get()
            .load("https://room-park.ru$source")
            .placeholder(R.drawable.ic_deals)
            .into(drawable)
        return drawable
    }

    private inner class BitmapDrawablePlaceHolder : BitmapDrawable(), Target{

        protected var _drawable: Drawable? = null

        private val resources: Resources = RoomParkApplication.component.provideAppContext().resources

        override fun draw(canvas: Canvas) {
            if (_drawable != null) {
                _drawable!!.draw(canvas)
            }
        }

        fun setDrawable(drawable: Drawable) {
            this._drawable = drawable
            var width = drawable.intrinsicWidth
            var height = drawable.intrinsicHeight
            target.let {
                val aspect = it.measuredWidthAndState.toFloat()/width.toFloat()
                height = (height*min(aspect,1.0f)).toInt()
                width = min(width,it.measuredWidthAndState)
                drawable.setBounds(0, 0, width, height)
                setBounds(0, 0, width, height)

                it.text=it.text
            }

        }

        override fun onBitmapLoaded(bitmap: Bitmap, from: Picasso.LoadedFrom) {
            setDrawable(BitmapDrawable(resources, bitmap))
        }

        override fun onBitmapFailed(e: Exception?, errorDrawable: Drawable?) {}

        override fun onPrepareLoad(placeHolderDrawable: Drawable) {

        }

    }
}